﻿Imports System.IO

Public Class FrmPuzzelGame
    Dim picinf As FileInfo
    Dim myext As String = ".gif|.jpg|.jpeg|.bmp|.wmf|.png"
    Dim MaxPict As Integer
    Dim cllctGambar As New Collection
    Dim pzlW As Integer
    Dim pzlH As Integer
    Dim borderW As Integer = 4
    Dim pzlLeft As Integer = borderW
    Dim pzlTop As Integer = borderW
    Dim StateAwal As Boolean = True
    Dim tmpSender As Object
    Dim TotJam As Integer = 0, TotMenit As Integer = 0, TotDetik As Integer = 0
    Dim UrutanPic As Integer = 0
    Dim tmpUrutanPic As Integer
    Dim collPost As New Collection
    Public Function LoadFilesFrom(ByVal AlamatFolder As String, ByRef CollctImage As Object, ByVal myext As String) As Integer

        Dim picno As Integer = 1
        Dim img As Image
        MaxPict = 0

        For Each thpic As String In Directory.GetFiles(AlamatFolder)
            Try
                picinf = New FileInfo(thpic)
                If myext.Contains(LCase(picinf.Extension)) Then                    '
                    img = Image.FromFile(picinf.FullName)
                    img = img.GetThumbnailImage(576, 427, Nothing, Nothing)
                    cllctGambar.Add(img, MaxPict)
                    MaxPict += 1
                    picno += 1
                End If

            Catch
            End Try
        Next

        LoadFilesFrom = picno - 1
    End Function
    Private Sub btnLoad_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLoad.Click

        If TimerScore.Enabled = True Then
            If MsgBox("O jogo esta em execução..." & vbCrLf & "Realmente deseja parar o jogo? (Y/N):", MsgBoxStyle.YesNo, "OK") = MsgBoxResult.No Then Exit Sub
            TimerScore.Enabled = False
            RemovePuzzel()
            btnStart.Text = "INICIAR"
        End If

        picMainPicture.Visible = True
        picMainPicture.BringToFront()

        TotJam = 0
        TotMenit = 0
        TotDetik = 0

        Dim Pil As Integer

        Pil = CInt((Rnd() * MaxPict) - 1) + 1


        If Pil < 1 Then Pil += 1
        If Pil > MaxPict - 1 Then Pil -= 1
        picMainPicture.Image = cllctGambar(Pil + 1) ' Image.FromFile(TextBox1.Text) & 
        pzlW = picMainPicture.Image.Width / TrackLevel.Value
        pzlH = picMainPicture.Image.Height / TrackLevel.Value

    End Sub
    Private Sub createPeacePuzz()

        Dim xRect As Rectangle
        xRect.Width = pzlW
        xRect.Height = pzlH
        xRect.X = 0
        xRect.Y = 0

        Dim pcPzl As PictureBox

        UrutanPic = 0
        collPost.Clear()

        Do While pzlTop < picMainPicture.Height

            UrutanPic += 1

            If pzlLeft > picMainPicture.Width Then
                pzlLeft = borderW
                pzlTop = pzlTop + pzlH + borderW
            End If

            If pzlTop > picMainPicture.Height Then Exit Do

            pcPzl = New PictureBox()

            pcPzl.BackColor = Color.Black
            pcPzl.Left = pzlLeft
            pcPzl.Top = pzlTop
            pcPzl.Width = pzlW
            pcPzl.Height = pzlH
            pcPzl.Visible = True
            pcPzl.Tag = CStr(UrutanPic) ' picinf.FullName

            collPost.Add(pcPzl, CStr(UrutanPic))
            PanelPuzzel.Controls.Add(pcPzl)



            Dim previewImage As New Bitmap(picMainPicture.Image)
            Dim gr As Graphics = Graphics.FromImage(previewImage)
            gr.DrawImage(picMainPicture.Image, xRect, (pzlLeft - (borderW * (pzlLeft \ pzlW))) - borderW, (pzlTop - (borderW * (pzlTop \ pzlH))) - borderW, pzlW, pzlH, GraphicsUnit.Pixel)

            pcPzl.SizeMode = PictureBoxSizeMode.StretchImage
            pcPzl.BackgroundImage = Image.FromHbitmap(previewImage.GetHbitmap) 'DrawImage(picMainPicture.Image, xRect, Left, Top, pzlW, pzlH, GraphicsUnit.Pixel)
            previewImage = Nothing
            gr = Nothing

            AddHandler pcPzl.Click, New System.EventHandler(AddressOf PuzzelClick)
            AddHandler pcPzl.MouseHover, New System.EventHandler(AddressOf PuzzelMouseHover)
            AddHandler pcPzl.MouseLeave, New System.EventHandler(AddressOf PuzzelMouseLeave)


            pzlLeft = pzlLeft + pzlW + borderW

        Loop
        MsgBox("Quer remontar este quebra-cabeças !")
    End Sub

    Sub PuzzelClick(ByVal sender As Object, ByVal e As System.EventArgs)
        Try
            If StateAwal = True Then

                picTemp.BackgroundImage = sender.backgroundimage ' Image.FromFile(sender.tag)

                sender.image = picHighLightFcs.Image
                tmpSender = sender
                tmpUrutanPic = sender.tag
                StateAwal = False
            Else
                tmpSender.backgroundimage = sender.backgroundimage
                tmpSender.tag = sender.tag
                sender.backgroundimage = picTemp.BackgroundImage
                tmpSender.image = Nothing
                tmpSender = picTemp

                sender.tag = tmpUrutanPic

                StateAwal = True
            End If
            btnKebenaran_Click(sender, e)

        Catch ex As Exception
            MsgBox(ex.Message, 48)
        End Try
    End Sub
    Sub PuzzelMouseHover(ByVal sender As Object, ByVal e As System.EventArgs)

        If sender.Equals(tmpSender) = True Then
        Else
            sender.image = PicHighlight.Image
        End If

    End Sub

    Sub PuzzelMouseLeave(ByVal sender As Object, ByVal e As System.EventArgs)
        If sender.Equals(tmpSender) = True Then
        Else
            sender.image = Nothing ' picHighLightFcs.Image
        End If
        Try

        Catch ex As Exception
            MsgBox(ex.Message, 48)
        End Try
    End Sub

    Private Sub btnShow_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnShow.Click

        If btnShow.Text = "Visualizar" Then
            picMainPicture.Visible = True
            picMainPicture.BringToFront()
            btnShow.Text = "Ocultar"
        Else
            picMainPicture.Visible = False
            picMainPicture.SendToBack()
            btnShow.Text = "Visualizar"
        End If

    End Sub



    Private Sub btnStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStart.Click
        picMainPicture.Visible = False
        picMainPicture.SendToBack()
        Randomize()
        If btnStart.Text = "INICIAR" Then

            If TrackLevel.Value > 7 Then
                lblStatus.Text = "Difícil"
            ElseIf TrackLevel.Value > 4 Then
                lblStatus.Text = "Normal"
            Else
                lblStatus.Text = "Fácil"
            End If



            TimerScore.Enabled = True
            picMainPicture.Visible = False
            picMainPicture.SendToBack()
            pzlLeft = borderW
            pzlTop = borderW
            RemovePuzzel()
            createPeacePuzz()
            randomPuzzPos()
            TimerScore.Enabled = True
            btnStart.Text = "PARAR"
        Else
            btnLoad_Click(sender, e)

        End If



    End Sub

    Private Sub TrackLevel_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TrackLevel.Scroll
        pzlW = picMainPicture.Image.Width / TrackLevel.Value
        pzlH = picMainPicture.Image.Height / TrackLevel.Value
    End Sub

    Private Sub TimerScore_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TimerScore.Tick
        TotDetik += 1
        If TotDetik > 60 Then
            TotMenit += 1
            TotDetik = 0
            If TotMenit > 60 Then
                TotJam += 1
                TotMenit = 0
            End If
        End If
        lblTimer.Text = Format(TotJam, "00") & ":" & Format(TotMenit, "00") & ":" & Format(TotDetik, "00")
    End Sub



    Private Sub PanelPuzzel_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles PanelPuzzel.Paint

    End Sub

    Private Sub btnKebenaran_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnKebenaran.Click
        Dim iCorrect As Integer = 0
        Dim Benar As Boolean = True

        For ctrl As Integer = 0 To PanelPuzzel.Controls.Count - 1


            If PanelPuzzel.Controls(ctrl).Name <> picMainPicture.Name Then
                iCorrect += 1
                If PanelPuzzel.Controls(ctrl).Tag <> CStr(iCorrect) Then Benar = False
            End If

        Next
        If Benar = True Then
            TimerScore.Enabled = False
            MsgBox("Parabéns ! Você passou este nível """ & lblStatus.Text & """ (" & TrackLevel.Value & "X" & TrackLevel.Value & ") Tempo " & lblTimer.Text, MsgBoxStyle.OkOnly, "Ganhou!")
            btnStart.Text = "INICIAR"
            RemovePuzzel()
            picMainPicture.BringToFront()
            picMainPicture.Visible = True

            TotJam = 0
            TotMenit = 0
            TotDetik = 0
        End If
    End Sub
    Private Sub RemovePuzzel()
        For ctrl As Integer = PanelPuzzel.Controls.Count - 1 To 0 Step -1
            If PanelPuzzel.Controls(ctrl).Name <> picMainPicture.Name Then PanelPuzzel.Controls.Remove(PanelPuzzel.Controls(ctrl))
        Next
    End Sub
    Private Sub randomPuzzPos()
        Dim il As Integer
        Dim rndVal As Integer
        Dim tmpTag As String
        Dim img As Image

        For il = 1 To collPost.Count
            rndVal = Int(Rnd() * ((TrackLevel.Value * TrackLevel.Value) - 1)) + 1
            img = collPost.Item(il).backgroundimage
            collPost.Item(il).backgroundimage = collPost.Item(rndVal).backgroundimage 'picMainPicture.Image
            collPost.Item(rndVal).backgroundimage = img

            tmpTag = collPost.Item(il).tag
            collPost.Item(il).tag = collPost.Item(rndVal).tag 'picMainPicture.Image
            collPost.Item(rndVal).tag = tmpTag
        Next

    End Sub
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click

        randomPuzzPos()
    End Sub

    Private Sub PictureBox1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PictureBox1.Click

    End Sub

    Private Sub FrmPuzzelGame_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        LoadFilesFrom(Application.StartupPath & "\ForGamePuzzle", cllctGambar, myext) ' Application.StartupPath & "\GameResources", cmbGambar, myext)
        btnLoad_Click(sender, e)
    End Sub

    Private Sub FrmPuzzelGame_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        picBorder.Width = PnlControl.Left - 30
        picBorder.Height = PnlControl.Height - 50
        PanelPuzzel.Width = picBorder.Width - 15
        PanelPuzzel.Height = picBorder.Height - 15
    End Sub
End Class